#!/bin/sh
#Editeur.tcl
# Licence : GNU/GPL Version 2 ou plus
# \
exec wish "$0" ${1+"$@"}

############################################################################
# Copyright (C) 2002 David Lucardi
# Copyright (C) 2004 ric Seigne <eric.seigne@ryxeo.com>
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307,USA.
############################################################################
# File  :  can2html.tcl - inspir des travaux de Mats Bengtsson et de can2svg
# Author  : David Lucardi
#           mailto: DavidLucardi@aol.com
# Date    : 26/04/2002
# Licence : GNU/GPL Version 2 ou plus
#
# Description:
# ------------
#
# @version
# @author     David Lucardi
# @project
# @copyright  David Lucardi 08/05/2004
#
#
#########################################################################


#test d'exporter tout en html par eric (mai 2004)
#j'ai repris le fichier can2svg de david :)

#
# Priorits:
#  - exporter les images dans des fichiers html avec le placement x/y
#    respect
#  - transformer les "formes" kidist en images gif/png pour faire les
#    flches et autres formes
#  - grer le passage d'une page  l'autre !
#  - grer les animations (arg javascript bonjour)
#  - stop :=)
#
namespace eval ::can2html:: {
    #export du canvas canId en fichier jpeg (/tmp/test.jpeg pour les tests)
    proc can2jpeg { canId } {
	set retVal [catch {image create photo -format window -data $canId} ph]
	$ph write /tmp/test.jpeg -format JPEG
    }


    #######################################################################"
    #en html il faudrait aussi convertir les lettres accentues mais je n'ai
    #pas a comme priorit :)
    proc substexte {texte} {
	return [string map { "&#x00FB;"  "&#x00E0;"  "&#x00F9;"  "&#x00E8;"  "&#x00E9;"  "&#x00EA;"  "&#x00EB;"  "&#x00EE;"  "&#x00E7;"  "&#x00E2;"  "&#x00EF;"  "&#x00F4;"  "&#x00F6;"  "&#x00FC;"} $texte]
    }
    #######################################################################"
    #pour les images c'est simple: un lien, une position et c'est tout
    proc createimage {c fichier x y zoom1 zoom2 identif} {
	global html Home
	image create photo bimage -file [file join $Home images $fichier]
	set width [expr [image width bimage]*$zoom1] 
	set height [expr [image height bimage]*$zoom2]
	set x0 [expr $x - $width/2]
	set y0 [expr $y - $height/2]
	if {$x0 <0} {set x0 0}
	if {$y0 <0} {set y0 0}
	lappend  html $identif
	lappend html "<div id=\"image_$fichier\" style=\"position: absolute;top: $y0;left: $x0\"><img width=\'$width\' height=\'$height\' src='./images/$fichier'/></div>\n"
	
    }
    
    ########################################################################"
    #les boutons c'est normalement pas beaucoup plus compliqu
    proc createbouton2 {c fichier x y zoom1 zoom2 identif texte police coul} {
	global html Home
	image create photo bimage -file [file join $Home images $fichier]
	set width [expr [image width bimage]*$zoom1] 
	set height [expr [image height bimage]*$zoom2]
	set x0 [expr $x - $width/2]
	set y0 [expr $y - $height/2]
	if {$x0 <0} {set x0 0}
	if {$y0 <0} {set y0 0}
	lappend  html back$identif
	lappend html "on est ici: <a id=\"image_$fichier\" style=\"position: absolute;top: $y0;left: $x0\" href='./images/$fichier'/>Lien</a>\n"
	
	#set textWidth [expr [font measure {Helvetica 16 bold} $texte] - 2*[string length $texte]]
	
	set taille [expr int((12*4)/3) -1]
	set fontm "Helvetica $taille bold"
	set textWidth [font measure $fontm $texte]
	set ascent [font metrics $fontm -ascent]
	set lineSpace [font metrics $fontm -linespace]
	set x [expr $x - $textWidth/2.0]
	set y [expr $y - $lineSpace/2.0 + $ascent]
	if {$x <0} {set x 0}
	if {$y <0} {set y 0}
	lappend html $identif
	lappend html "<div id=\"text_$identif\" style=\"position: absolute; top:$y; left: $x; font-family: Helvetica; font-size : $taille;font-weight : bold;\">[substexte $texte]</div>\n"
    }
    #####################################################################"
    proc createtexte {c x y texte couleur largeur hauteur fillcouleur police taillepol trait identif sep} {
	global taillefont html plateforme
	set taille [lindex $taillefont $taillepol]
	
	set texte [string map {"\\n" " "} $texte]
	set lineSpace [font metrics "$police $taille" -linespace]
	set ascent [font metrics "$police $taille" -ascent]
	set indexv 0
	set indext 0
	set maxlength 0
	set data ""
	set delta 0
	
	set yt [expr $y + $ascent/2]
	if {$x <0} {set x 0}
	if {$y <0} {set y 0}
	
	set data "$data <div style=\"position: absolute; left: $x; top: $lineSpace;\">$texte</div>\n"
	switch $plateforme {
	    windows {
		set taille [expr int(([lindex $taillefont $taillepol]*4)/3) -1]
		if {$taillepol <=1} {set delta 2}
	    }
	    unix {
		if {$police != "Arial"} {
		    if {$taillepol >2}  {set delta -1}
		    if {$taillepol >5}  {set delta -3}
		}
	    }
	}
	
#afaire
#	if {$trait != ""} {
#	    if {$couleur == ""} {set couleur "none"}
#	    lappend html back$identif
#	    lappend html "<rect x=\'[expr $x -2]\' y=\'[expr $yt -2]\' width =\'[expr $largeur +6]\' height=\'$hauteur\' style='stroke : $trait; fill : $couleur;'/>\n"
#	}
	set taille [expr $taille + $delta]
	lappend html $identif
	if {$x <0} {set x 0}
	if {$y <0} {set y 0}
#	lappend html "<div id=\"text_$identif\" style=\"font-family: $police; font-size : $taille;fill: $fillcouleur;\">$data</div>\n"
	lappend html $data

	#set idtmp1 [$c create text $x $y -text [join $texte] -width $largeur -anchor n -font "$police [lindex $taillefont $taillepol]" -justify left -fill $fillcouleur -tags "drag $id typetext" ]
	
    }
    
    #################################################################"
    proc createpolygon {c fichier arrcoul linecoul smoth identif} {
	global html
	if {$smoth==1} {
	    set x0 [expr ([lindex $fichier end-1] + [lindex $fichier 0])/2.0]
	    set y0 [expr ([lindex $fichier end] + [lindex $fichier 1])/2.0]
	    set data "M $x0 $y0 Q"
	    set i 2
	    foreach {x y} [lrange $fichier 0 end-2] {
		set x1 [expr ($x + [lindex $fichier $i])/2.0]
		incr i
		set y1 [expr ($y + [lindex $fichier $i])/2.0]
		incr i
		append data " $x $y $x1 $y1"
		set root "path d="			    
	    }
	    append data " [lrange $fichier end-1 end] $x0 $y0"
	} else {
	    set data $fichier
	    set root "polygon points="			    
	} 
	
	lappend html $identif
	lappend html "<$root\'$data\' style='fill-rule : evenodd; stroke: $linecoul; fill : $arrcoul;'/>\n"
	
    }
    #################################################################
    proc createbouton1 {c fichier arrfill outcoul tag identif} {
	global html xindexpage
	
	set data $fichier
	set ext .html
	switch $tag {
	    # shape=\"$data\
	    pageprec {set text "<a href='page[expr $xindexpage -1]$ext'>Page prcdente</a>" }
	    pagesuiv {set text "<a href='page[expr $xindexpage +1]$ext'>Page suivante</a>" }
	    sommaire {set text "<a href='page1$ext'>Sommaire</a>" }
	}
	lappend xml $identif
	lappend html $text
	#$c create polygon $it -fill $arrfill -tags "drag $id $tag typebouton1" -outline $outcoul
	
    }
    
    
    ####################################################################"   
}
